function updateOwppocztaDatabase(){
    showNoticeMessage('Rozpoczęto aktualizację bazy danych, to może chwilę potrwać');
    $.post(owppoczta_link,function(data)
        {
            try {
                if (data && data.success){
                    showSuccessMessage(data.message);
                }
                else if(data && !data.success)
                    showErrorMessage(data.message);
                else
                    showErrorMessage("Wystąpił błąd w trakcie aktualizacji bazy danych!");
            } catch(e) {
                jAlert('Problem techniczny, prosimy o próbę za chwilę.');
            }
        },
        'json');
    return false;
}

function updateOwppocztaConfiguration(sel){
    $.post(owppoczta_ajax_url, { action:"updateConfiguration", name:sel.name, value:sel.value },function(data)
        {
            try {
                if (data && data.success){
                    showSuccessMessage(data.message);
                }
                else
                    showErrorMessage("Wystąpił błąd w trakcie aktualizacji bazy danych!");
            } catch(e) {
                jAlert('Problem techniczny, prosimy o próbę za chwilę.');
            }
        },
        'json'
    );
    return false;
}

function setOwppocztaConnected(carrier_id, add, place_type_name){
    $.post(owppoczta_ajax_url, { action:"setConnected", value:(add ? 'add' : 'remove'), id_carrier: carrier_id, place_type_name: place_type_name},function(data)
        {
            try {
                if (data && data.success){
                    showSuccessMessage(data.message);
                    if (add)
                        $("#tr_"+carrier_id.value).addClass('connected');
                    else
                        $("#tr_"+carrier_id.value).removeClass('connected');
                }
                else
                    showErrorMessage("Wystąpił błąd w trakcie aktualizacji bazy danych!");
            } catch(e) {
                jAlert('Problem techniczny, prosimy o próbę za chwilę.');
            }
        },
        'json');
    return false;
}

function removeOwppocztaLogs()
{
    $.post(owppoczta_ajax_url, { action:"removeLogs" } , function(data)
        {
            try {
                if (data && data.success){
                    showSuccessMessage("Logi zostały usunięte.");
                    jQuery('.owppoczta-logs-table tbody tr').hide();
                    jQuery("#log-list-empty").show();
                }
                else
                    showErrorMessage("Wystąpił błąd w trakcie usuwania logów!");
            } catch(e) {
                jAlert('Problem techniczny, prosimy o próbę za chwilę.');
            }
        },
        'json');
}

if (typeof(showNoticeMessage) !== 'function'){
    function showNoticeMessage(message){
        return showSuccessMessage(message);
    }
}
