var owppocztaMap;

function saveChosenPost(pni) {
    jQuery.post(owppoczta_ajax_path,
        {action: "saveChosenPost", pni: pni},
        function (data) {
            try {
                if (data && data.success) {
                    show_alert('Pomyślnie zapisano wybraną placówkę jako punkt odbioru przesyłki.', 'success');
                    setTimeout(hide_owppoczta_container, 5000);
                }
                else
                    show_alert('Wystąpił problem w trakcie zapisywania wybranej placówki pocztowej.', 'warning');
            } catch (e) {
                show_alert('Wystąpił problem z obsługą skryptów Javascript.', 'danger');
            }
        },
        'json'
    );

}

function show_owppoczta_container() {
    var owppocztaContainer = jQuery('.owppoczta-container');
    if (!owppocztaContainer.hasClass('big')) {
        jQuery('#owppoczta-overlay').show().animate({"opacity": 1});
        owppocztaContainer.addClass('big');
        owppoczta_map_init(parseFloat(owppoczta_lat), parseFloat(owppoczta_lng), owppoczta_zoom);
    }
}
function hide_owppoczta_container() {
    jQuery('#owppoczta-overlay').animate({"opacity": 0}).hide();
    jQuery('.owppoczta-container').removeClass('big');
}

function owppoczta_map_init(lat, lng, zoom) {
    owppocztaMap = new google.maps.Map(document.getElementById('owppoczta-map'), {
        center: {lat: lat, lng: lng},
        zoom: zoom,
        disableDefaultUI: true
    });
    showMarker(lat, lng, '');
}

function moveToLocation(lat, lng, zoom) {
    owppoczta_lat = lat;
    owppoczta_lng = lng;
    zoom = typeof zoom !== 'undefined' ? zoom : 16;
    var center = new google.maps.LatLng(lat, lng);
    // using global variable:
    owppocztaMap.setZoom(zoom);
    owppocztaMap.panTo(center);
}

function showMarker(lat, lng, title) {
    var marker = new google.maps.Marker({
        position: new google.maps.LatLng(lat, lng),
        map: owppocztaMap,
        title: title
    });
}

function formatResult(postOffice) {
    if (!postOffice.PNI) return postOffice.text; // optgroup
    return "<strong>" + postOffice.nazwa_placowki + "</strong><br/><small>" + postOffice.ulica + " " + postOffice.kod_pocztowy + " " + postOffice.miejscowosc + "</small>";

}

function formatSelection(postOffice) {
    if (!postOffice.PNI) return postOffice.text;
    return "<strong>" + postOffice.nazwa_placowki + "</strong> " + postOffice.ulica + " " + postOffice.kod_pocztowy + " " + postOffice.miejscowosc;
}

function show_alert(message, type) {
    jQuery('.owppoczta-alert').text(message).addClass('alert-' + type).show();
}

function exitWithoutChoose(message) {
    message = typeof message !== 'undefined' ? message : "Nie wybrałeś placówki w której chcesz odebrać przesyłkę!";
    if(message != ''){
        window.onbeforeunload = function () {
            return message;
        };
    }else{
        window.onbeforeunload = null;
    }

}
