<?php

/**
 * Class OwppocztaCarrier
 */
class OwppocztaCarrier
{
    /**
     * Nazwa miejsca odbioru przesyłki, taka sama jak w plikach CSV udostępnianych przez Pocztę Polską
     * @var string
     */
    protected $name;

    /**
     * Nazwa pliku obrazka wyświetlanego
     * @var string
     */
    protected $image;

    /**
     * @var string
     */
    protected $header_text;

    /**
     * Kolor tła
     * @var string
     */
    protected $background_color;

    /**
     * @param $name
     * @param $header_text
     * @param null $background_color
     * @param null $image
     */
    public function __construct($name, $header_text, $background_color = null, $image = null)
    {
        $this->name = $name;
        $this->header_text = $header_text;
        $this->background_color = $background_color;
        $this->image = $image;
    }


    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @return string
     */
    public function getHeaderText()
    {
        return $this->header_text;
    }

    /**
     * @return string
     */
    public function getImage()
    {
        return $this->image;
    }

    /**
     * @return string
     */
    public function getBackgroundColor()
    {
        return $this->background_color;
    }

    /**
     * Zwraca optymalny kolor tekstu na podstawie koloru tła
     * Czarny lub biały
     * @return string
     */
    public function getTextColor()
    {
        list($r, $g, $b) = sscanf($this->background_color, "#%02x%02x%02x");
        if ($r + $g + $b > 127)
            return '#000000';
        else
            return '#FFFFFF';
    }
}

