<?php

/**
 * Klasa odpowiadająca za zapisywanie i kasowanie logów
 * Class OwppocztaLogger
 */
class OwppocztaLogger
{
    /**
     * Nazwa pliku z logami
     */
    const OWPPOCZTA_LOG = 'owppoczta.log';
    /**
     * Zapamiętuję logi z jedynie dziewięciu ostatnich aktualizacji - powinno być wystarczające
     */
    const OWPPOCZTA_FILE_LENGTH = 18;

    /**
     * @param $status_id
     * @param $log
     * @return string
     */
    static public function saveLog($status_id, $log)
    {
        switch ($status_id) {
            case 10:
                $status = 'OK';
                break;
            case 5:
                $status = 'WARNING';
                break;
            default:
                $status = 'ERROR';
        }
        $file = @fopen(OWPPOCZTA_PATH . 'logs/'. self::OWPPOCZTA_LOG, 'a');
        if (!$file) {
            return 'Wystąpił problem w trakcie zapisywania logów. Prosze sprawdzić, czy dla folderu "'.OWPPOCZTA_PATH . 'logs/'.'" skrypt ma prawa do zapisu.';
        } else {
            fwrite($file, date('Y-m-d G:i:s'). "\t" .$status . "\t" . $log.PHP_EOL);
            fclose($file);
            self::cutFileLength();
            return $status . "\t" . $log.'<br/>';
        }
    }

    /**
     * @return array|bool
     */
    static public function getLogs(){
        if(file_exists(OWPPOCZTA_PATH . 'logs/'. self::OWPPOCZTA_LOG)) {
            $logs = file(OWPPOCZTA_PATH . 'logs/' . self::OWPPOCZTA_LOG, FILE_IGNORE_NEW_LINES);
            foreach ($logs as $key => $log) {
                $logs[$key] = explode("\t", $log);
            }
            return array_reverse($logs);
        }else
            return false;
    }

    /**
     * @return bool
     */
    static public function removeLogs(){
        return fclose(fopen(OWPPOCZTA_PATH . 'logs/'. self::OWPPOCZTA_LOG, "w"));
    }

    /**
     * @return bool
     */
    static private function cutFileLength(){
        $logs = file(OWPPOCZTA_PATH . 'logs/'. self::OWPPOCZTA_LOG, FILE_IGNORE_NEW_LINES);
        if(is_array($logs) && count($logs) > self::OWPPOCZTA_FILE_LENGTH) {
            $logs = array_slice($logs, -self::OWPPOCZTA_FILE_LENGTH);
        }
        $file = @fopen(OWPPOCZTA_PATH . 'logs/'. self::OWPPOCZTA_LOG, 'w');
        if ($file) {
            foreach ($logs as $log) {
                fwrite($file, $log . PHP_EOL);
            }
            fclose($file);
        return true;
        }
    return false;
    }
}
