<?php
/**
 * Created by PhpStorm.
 * User: Michał Mleczko
 * Date: 2015-04-14
 * Time: 21:35
 */

/**
 * Class OwppocztaOrder
 */
class OwppocztaOrder
{

    /**
     * ID koszyka
     * @var
     */
    private $id_cart;
    /**
     * Numer PNI placowki pocztowej
     * @var
     */
    private $pni;

    /**
     * ID sposobu przesyłki
     * @var integer
     */
    private $id_carrier;

    /**
     * @param $id_cart
     * @param null $pni
     */
    public function __construct($id_cart, $pni = null, $id_carrier = null)
    {
        $this->id_cart = $id_cart;

        if (!is_null($pni)) {
            $this->pni = $pni;
            $this->id_carrier = $id_carrier;
        } else {
            $sql = sprintf('
                SELECT pni, id_carrier from %sowppoczta_orders where id_cart = %d',
                _DB_PREFIX_,
                $id_cart);
            $row = Db::getInstance()->getRow($sql);
            if($row){
                $this->pni = $row['pni'];
                $this->id_carrier = $row['id_carrier'];
            }
        }
    }

    /**
     * @return int
     */
    public function getPni()
    {
        return $this->pni;
    }

    /**
     * @return int
     */
    public function getIdCart()
    {
        return $this->id_cart;
    }

    /**
     * @return int
     */
    public function getIdCarrier()
    {
        return $this->id_carrier;
    }



    /**
     * @return bool
     */
    public function save()
    {
        $sql = sprintf('
                REPLACE INTO %sowppoczta_orders (pni, id_cart, id_carrier) VALUES( %d, %d, %d);',
            _DB_PREFIX_,
            $this->pni,
            $this->id_cart,
            $this->id_carrier);
        return Db::getInstance()->execute($sql);
    }

    /**
     * @return bool
     */
    public function remove()
    {
        $sql = sprintf('
                DELETE FROM %sowppoczta_orders WHERE id_cart = %d;',
            _DB_PREFIX_,
            $this->id_cart);
        return Db::getInstance()->execute($sql);
    }

}