<?php

/**
 * Class OwppocztaPostOffice
 */
class OwppocztaPostOffice
{

    public $address_array = array();

    /**
     * @param null $PNI
     */
    public function __construct($PNI = null)
    {
        if (!is_null($PNI)) {
            $sql = 'SELECT *
		FROM `' . _DB_PREFIX_ . 'placowki_poczty`
		WHERE pni = "' . $PNI . '"';
            $this->address_array = Db::getInstance()->getRow($sql);
        }
    }

    /**
     * @param $pni
     * @return mixed
     */
    public static function get_post_by_pni($pni)
    {
        $sql = sprintf('SELECT *
		    FROM `' . _DB_PREFIX_ . 'placowki_poczty`
		    WHERE pni = "%d"',
            $pni);
        return Db::getInstance()->getRow($sql);
    }

    /**
     * @param $postname
     * @param array() $place_types
     * @param $per_page
     * @param $page
     * @param bool|false $count
     * @return array|int
     * @throws PrestaShopDatabaseException
     */
    public static function get_posts_offices_by_name($postname, $place_types, $per_page, $page, $count = false)
    {
        if($postname && $place_types) {
            if(!is_array($place_types))
                $place_types = array($place_types);

            //usuń niepotrzebne znaki z zapytania (jeśli ktoś oddzieliłby miasto od ulicy przecinkiem)
            $address_array = str_replace(array(","), "", $postname);

            //rozdziel zapytanie na poszczególne wyrazy
            $address = explode(' ', $address_array);

            //jeśli nazwa jest dwuczłonowa, sprawdź czy drugi człon nie jest nazwą ulicy
            //@TODO wyszukiwanie po ulicy w miejscowościach dwuczłonowych
            $sql = sprintf('SELECT *
              FROM %s%s AS pp
              WHERE (pp.stan_placowki = "" OR pp.stan_placowki IS NULL)
              AND pp.typ IN ("%s")
              AND (
              (pp.nazwa_placowki LIKE "%%%s%%"
              OR pp.miejscowosc LIKE "%%%s%%")
              ',
                _DB_PREFIX_,
                DATABASE_PLACOWKI_POCZTY,
                implode('","', $place_types),
                implode(' ', $address),
                implode(' ', $address));

            if (count($address) === 2) {
                $sql .= sprintf('OR (pp.nazwa_placowki LIKE "%%%s%%"
		    AND pp.miejscowosc LIKE "%%%s%%") OR (pp.miejscowosc LIKE "%%%s%%"
		    AND pp.ulica LIKE "%%%s%%")',
                    $address[0],
                    $address[1],
                    $address[0],
                    $address[1]);
            } elseif (count($address) === 3) {
                $sql .= sprintf('OR (pp.nazwa_placowki LIKE "%%%s%%"
		    AND pp.miejscowosc LIKE "%%%s%%" AND pp.ulica LIKE "%%%s%%") OR ((pp.miejscowosc LIKE "%%%s%%"
		    OR pp.miejscowosc LIKE "%%%s%%") AND pp.ulica LIKE "%%%s%%")',
                    $address[0],
                    $address[1],
                    $address[2],
                    $address[0],
                    $address[1],
                    $address[2]);
            }
            $sql .=')';

            if ($count)
                return count(Db::getInstance()->ExecuteS($sql));
            $sql .= sprintf('
                LIMIT %d
                OFFSET %d;',
                $per_page,
                $page * $per_page);

            return Db::getInstance()->ExecuteS($sql);
        }
        return false;
    }
    /**
     * Zwraca pocztę o podanym kodzie pocztowym lub pięć najbliższych placówek
     * @param $postcode
     * @param $place_types
     * @param int $page_limit
     * @param int $page
     * @param bool|false $count
     * @return array|bool|int
     * @throws PrestaShopDatabaseException
     */
    public static function get_posts_offices_by_nearest_postcode($postcode, $place_types, $page_limit = 30, $page = 0, $count = false)
    {
        if ($postcode and $place_types) {
            if(!is_array($place_types))
                $place_types = array($place_types);

            $sql = sprintf('FROM `' . _DB_PREFIX_ . DATABASE_PLACOWKI_POCZTY . '` AS pp
		    INNER JOIN(
			    SELECT `pni`
			    FROM `' . _DB_PREFIX_ . DATABASE_PLACOWKI_POCZTY_PNAPNIPP . '`
        	    WHERE `PNA` LIKE "%s%%") AS pnapni
		    WHERE pnapni.pni = pp.pni
		    AND (pp.stan_placowki = "" OR pp.stan_placowki is null)
		    AND pp.typ IN ("%s")
		    ', $postcode,
                implode('","', $place_types));
            if ($count) {
                return count(Db::getInstance()->ExecuteS('SELECT DISTINCT *
        ' . $sql));
            } else {
                $sql = sprintf('SELECT DISTINCT *
            %s
            LIMIT %d
		    OFFSET %d;', $sql, $page_limit, $page * $page_limit);

                $nearest_posts = Db::getInstance()->ExecuteS($sql);
                if (is_array($nearest_posts) && count($nearest_posts) > 0) {
                    foreach ($nearest_posts as &$post) {
                        if ($post['kod_pocztowy'] === $postcode) {
                            $temp = $nearest_posts[0];
                            $nearest_posts[0] = $post;
                            $post = $temp;
                        }
                    }
                    return $nearest_posts;
                }
            }
        }
        return false;
    }
}