<div id="owppoczta-overlay" onclick="hide_owppoczta_container();"></div>
<div class="owppoczta-container">
    <a name="poczta_lnk"></a>
    <div class="owppoczta-form">
        <label for="owppoczta-place-select" class="hidden">
            Wybierz punkt w którym chcesz odebrać paczkę:
        </label>
        <select id="owppoczta-place-select" name="owppoczta-place-select" class="js-data-example-ajax">
            <option value="{if $poczta}{$poczta['PNI']}{/if}"
                    selected="selected">{if $poczta}<strong><b>{$poczta['nazwa_placowki']}</b></strong> {$poczta['ulica']} {$poczta['kod_pocztowy']}, {$poczta['miejscowosc']}{/if}</option>
        </select>
    </div>
    <div class="map-container">
        <div id="owppoczta-map">
        </div>
        <div class="alert owppoczta-alert">
        </div>
    </div>
    <script type="text/javascript">
        var owppoczta_ajax_path = "{$ajax_url}";
        var owppoczta_lat = {if $poczta}{$poczta['y']}{else}51.9757845{/if};
        var owppoczta_lng = {if $poczta}{$poczta['x']}{else}20.0509901{/if};
        var owppoczta_zoom = {if $poczta}16{else}6{/if};

        {if not $poczta}
        exitWithoutChoose();
        {/if}

        jQuery('#owppoczta-place-select').select2({
            placeholder: "Wybierz punkt w którym chcesz odebrać paczkę",
            allowClear: true,
            ajax: {
                type: 'POST',
                url: "{$ajax_url}",
                delay: 250,
                dataType: 'json',
                data: function (params) {
                    return {
                        postoffice: params.term,
                        action: "getPostsList",
                        page_limit: 30,
                        page: params.page
                    };
                },
                results: function (data) {
                    //console.log(data);
                    return {
                        results: data
                    };
                },
                processResults: function (data, params) {
                    $.map(data.results, function (obj) {
                        obj.id = obj.id || obj.PNI;
                        return obj;
                    });
                    params.page = params.page || 0;
                    return {
                        results: data.results,
                        pagination: {
                            more: ((params.page + 1) * 30) < data.total_count
                        }
                    };
                },
                cache: true
            },
            id: function (element) {
                console.log(element);
                return element.PNI;
            },
            templateResult: formatResult,
            templateSelection: formatSelection,
            escapeMarkup: function (markup) {
                return markup;
            }, // let our custom formatter work
            minimumInputLength: 1,
            dropdownCssClass: "bigdrop",
            language: {
                inputTooShort: function () {
                    return "Podaj kod pocztowy lub nazwę i adres placówki";
                },
                loadingMore: function () {
                    return 'Trwa ładowanie placówek…';
                },
                errorLoading: function () {
                    return "Nie można załadować wyników."
                }, noResults: function () {
                    return "Brak wyników"
                }, searching: function () {
                    return "Trwa wyszukiwanie…"
                }
            }
        }).on("select2:opening", function () {
            show_owppoczta_container();
        }).on("select2:select", function () {
            var data = jQuery(this).select2('data');
            moveToLocation(data[0].y, data[0].x);
            showMarker(data[0].y, data[0].x, data[0].nazwa_placowki);
            saveChosenPost(data[0].PNI);
            exitWithoutChoose(null);
        }).on("select2:unselect", function () {
            saveChosenPost('');
            exitWithoutChoose();
        });
        {if not $poczta}jQuery( document ).ready(function() {
            show_owppoczta_container();
        });{/if}
    </script>
    <span class="owppoczta-close" onclick="hide_owppoczta_container();"></span>
</div>